import pandas as pd
import datetime
import platform
import subprocess
import os
import sys
import ui
import texty
from multiprocessing import freeze_support
"""
OBC2Conc by Magnus Nissel
"""

"""
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.
"""

"""

This is very much a work-in-progress. 
Several features are missing and there is some refactoring to be done.

"""


corpus_dir = os.path.join(os.path.dirname(os.path.realpath(sys.argv[0])), "corpus")
FILES = set([os.path.join(dp, f) for dp, dn, fn in os.walk(os.path.expanduser(corpus_dir))
             for f in fn if 'OBC2' in f])

def open_file_externally(file_path):
    if platform.system() == "Windows":
        os.startfile(csv_path)
    elif platform.system() == "Darwin":
        subprocess.Popen(["open", file_path])
    else:
        subprocess.Popen(["xdg-open", file_path])


def list_files(pos=False, start_year=1720, end_year=1913):
    if pos:
        files = set([f for f in FILES if '.xml' in f and 'POS-' in f])
    else:
        files = set([f for f in FILES if '.xml' in f and 'POS-' not in f])
    relevant_files = set()
    for f in files:
        year = int(os.path.basename(f).replace(".xml", "")[-8:-4])
        if year >= start_year and year <= end_year:
            relevant_files.add(f)
    return relevant_files


def worker_create_list(options, return_shared, pipe):
    start_time = datetime.datetime.now() 
    files = list_files(False, options['start_year'], options['end_year'])
    token_bound = r"[^0-9A-Za-z'-]"

    if options["iterate"]:
        freq_list = texty.XMLIterFreqList(elem_list=["u"], att_dict=options['att_dict'],
                                          att_logic=options['att_logic'], token_bound = token_bound,
                                          min_length=1)
    else:
        freq_list = texty.XMLFreqList(elem_list=["u"], att_dict=options['att_dict'],
                                      att_logic=options['att_logic'],token_bound = token_bound,
                                      min_length=1)   
    freq_list.mp_from_file_list(files, pipe=pipe)  
    return_shared.append(freq_list.word_count)


def worker_search_files(options, return_shared, pipe):
    files = list_files(options['pos'], options['start_year'], options['end_year'])
    concordance = texty.Concordance(search_str=options['regex'])
    concordance.mp_from_file_list(files, is_plaintext=False, elem_list=["u"], attr_as_meta=True, 
                                  pipe=pipe)
    conc_df = pd.DataFrame.from_dict(concordance.conc_lines)
    return_shared.append(conc_df)


def run():
    app = ui.OBCInterface()

if __name__ == "__main__":
    freeze_support()
    run()
